#Bag of little bootstrap
set.seed(1)
n = 1000
x = rnorm(n)
sigma = 1
beta = c(1,0.5)

eta = beta[1]+beta[2]*x+sigma*rnorm(n)
#y = rbinom(n,1,prob=exp(eta)/(1+exp(eta)))
y = eta + sigma*rnorm(n)
d = data.frame(x=x,y=y)
FAM = "binomial"
FAM = "gaussian"
#Ordinary bootstrap
S=200
beta1.hat = rep(NA,S)
for(b in 1:S)
{
  ind = sample(1:n,n,replace=T)
  d.star = d[ind,]
  fit = glm(y~x,data=d.star,family=FAM)
  beta1.hat[b] = coef(fit)[2]
}
show(sd(beta1.hat))


S = 200
m = 30
B=200
beta1.hat = matrix(nrow=S,ncol=B)
sd.beta1 = rep(NA,S)
for(i in 1:S)
{
  ind = sample(1:n,m,replace=F)
  d2 = d[ind,]
  for(j in 1:B)
  {
    ind2 = sample(1:m,n,replace=T)
    w = (table(c(1:m,ind2))-1)
    fit = glm(y~x,data=d2,weights=w,family=FAM)
    beta1.hat[i,j] = coef(fit)[2]
  }
  sd.beta1[i] = sd(beta1.hat[i,]) 
}
show(mean(sd.beta1))

library(datadr)
#adult <- read.table("../data/adult.data",sep=",",
#                    col.names=c("age","workclass","fnlwght","education","education-num","marital-status",
#                                "occupation","relationship","race","sex",
#                                "capital-gain","captial-loss","hours-per-week","native-country","y"),
#                    colClasses=c("numeric","factor","numeric","factor","numeric","factor","factor","factor",
#                                 "factor","factor","numeric","numeric","numeric","factor","factor"))
                    
fit = glm(incomebin~educationnum + hoursperweek + sex+marital,data=adult,family=binomial)
fit = glm(incomebin~.,data=adult,family=binomial)
## Not run:
# BLB is meant to run on random replicate divisions
rrAdult <- divide(adult, by = rrDiv(1000), update = TRUE)
adultBlb <- rrAdult %>% addTransform(function(x) {
  drBLB(x,
        statistic = function(x, weights)
          coef(glm(incomebin ~ educationnum + hoursperweek + sex+marital,
                   data = x, weights = weights, family = binomial())),
        metric = function(x)
          quantile(x, c(0.05, 0.95)),
        R = 100,
        n = nrow(rrAdult)
  )
})
# compute the mean of the resulting CI limits
# (this will take a little bit of time because of resampling)
coefs <- recombine(adultBlb, combMean)
matrix(coefs, ncol = 2, byrow = TRUE)
## End(Not run)